{% extends '::base.html.twig' %}

{% block title %}{{ title }}{% endblock title %}

{% form_theme form '::Forms/bootstrapForm.html.twig' %}
{% form_theme form.pagosTarjeta with ['::Forms/bootstrapForm.html.twig', '::Forms/dateMonthYear.html.twig'] %}
{% form_theme formClient '::Forms/bootstrapForm.html.twig' %}
{% form_theme formDireccion '::Forms/bootstrapForm.html.twig' %}

{% block info %}
<div><span>{{ app.user.uClave | upper }}</span></div>
{% endblock %}

{% block body %}
<div class="container generalContainer" id="pf_opmenu">
	<div class="panel panel-default">
		<div class="panel-body">
			<div class="row">
				<div class="col-xs-3">
					<div>
						DID: <label id="dnis"></label>
					</div>
					<div>
						Cliente: <label id="callerId"></label>
					</div>
					<div>
						<span id="shortInfoCliente"></span>
					</div>
				</div>
				<div class="col-xs-3">
					{{ form_row(attribute(formOficinaVentas, "oficinaVentas")) }}
				</div>
			</div>
		</div>
	</div>
	{{ form_start(form) }}
	<ul class="nav nav-tabs" role="tablist">
	  <li class="active"><a href="#tabCliente" role="tab" data-toggle="tab">Cliente</a></li>
	  <li><a href="#tabDireccion" role="tab" data-toggle="tab">Direccion</a></li>
	  <li><a href="#tabProductos" role="tab" data-toggle="tab">Productos</a></li>
	  <li><a href="#tabPago" role="tab" data-toggle="tab">Pago</a></li>
	</ul>

	<div class="tab-content">
		<div class="tab-pane active" id="tabCliente">
			<div class="row">
				<div class="col-xs-9">
					{{ form_row(attribute(form, "cliente")) }}
				</div>
				<div class="col-xs-1">
				<button type="button" id="nuevoCliente" class="btn btn-default btn-lg"><span class="glyphicon glyphicon-plus"></span></button>
				</div>
			</div>
			<div class="row">
				<div class="col-xs-1"></div>
				<div class="col-xs-9">
					<div class="panel panel-info">
						<div class="panel-heading">Datos del cliente <button type="button" id="editarCliente" class="btn btn-default btn-sm" style="display:none;"><span class="glyphicon glyphicon-pencil"></span></button></div>
						<div class="panel-body" id="clienteInfoPanel">
							
						</div>
					</div>
				</div>
				<div class="col-xs-1"></div>
			</div>
		</div>
		<div class="tab-pane" id="tabDireccion">
			<div class="row">
				<div id="alertSinCoberturaDireccion" class="alert alert-warning alert-dismissible" style="display:none;">
					{#<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">×</span><span class="sr-only">Close</span></button>#}
					<div><b>Código Postal sin cobertura</b></div>
				</div>
				<div class="col-xs-10">
					{{ form_row(attribute(form, "direccion")) }}
				</div>
				<div class="col-xs-1">
				<button type="button" id="nuevaDireccion" class="btn btn-default btn-lg"><span class="glyphicon glyphicon-plus"></span></button>
				</div>
			</div>
			<div class="row">
				<div class="col-xs-1"></div>
				<div class="col-xs-9">
					<div class="panel panel-info">
						<div class="panel-heading">Datos de la dirección <button type="button" id="editarDireccion" class="btn btn-default btn-sm" style="display:none;"><span class="glyphicon glyphicon-pencil"></span></button></div>
						<div class="panel-body" id="direccionInfoPanel">
							
						</div>
					</div>
				</div>
				<div class="col-xs-1"></div>
			</div>
		</div>
		<div class="tab-pane" id="tabProductos">
			{{ form_row(attribute(form, "productos")) }}
			<div id="carrito">
				<div class="busqueda row">
					<div class="col-xs-3">
						{{ form_label(attribute(form, 'pago')) }}
						{{ form_widget(attribute(form, 'pago')) }}
					</div>
					<div class="col-xs-6">
						<button type="button" id="actualizarProductos" class="btn btn-default btn-sm"><span class="glyphicon glyphicon-refresh"></span></button>
						<label>Buscar: </label>
						<input id="filtroProductos" type="search" class="search form-control" />
						<div style="display:none"><button></button></div>
					</div>
					
					<div class="col-xs-3">
						<div class="totales">Importe: <span id="total"></span></div>
					</div>
				</div>
				<div class="table-container-disponibles">
					<table class="table table-bordered table-striped table-condensed">
						<thead>
							<tr>
								<th>Descripción</th>
								<th>Precio</th>
								<th></th>
							</tr>
						</thead>
						<tbody class="productosDisponibles"></tbody>
					</table>
				</div>
				<br/>
				<div class="table-container-seleccionados">
					<table class="table table-bordered table-striped table-condensed">
						<thead>
							<tr>
								<th>Cantidad</th>
								<th>Descripción</th>
								<th>PU</th>
								<th>Total</th>
								<th></th>
							</tr>
						</thead>
						<tbody class="productosSeleccionados"></tbody>
					</table>
				</div>
			</div>
			{% if productosCompra is not defined  %}
			{% set productosCompra = [] %}
			{% endif %}
			{% include 'MDRPuntoVentaBundle:Widgets:filterList.html.twig' with {
				'id': 'buscarProductos',
				'name': 'productos',
				'titulos': ['descripcion', 'precio'],
				'productosCompra' : productosCompra,
			} %}
		</div>
		<div class="tab-pane" id="tabPago">
			<div class="row">
				<div class="col-xs-5">
				{% for field in ['mensajeria', 'subTotal', 'gastosEnvio', 'totalPago', 'factura', 'rfc', 'submit',]
				    if (attribute(form, field) is defined) %}
				    {{ form_row(attribute(form, field)) }}
				{% endfor %}
				<div>
					<button type="button" class="btn btn-info" id="botonPreview" >Resumen</button>
					<button type="button" class="btn btn-warning" onclick="getTiempoEntrega()">Tiempo de Entrega</button>
				</div>
				</div>
				<div class="col-xs-7">
					<div id="pagoTarjetaPanel" class="panel panel-info">
						<div class="panel-heading">Datos de tarjeta</div>
  						<div class="panel-body">
							{% for pagoTarjeta in form.pagosTarjeta %}
								<div class="row">
									<div class="col-xs-6">
										{% for field in ['esTitular', 'titular', 'posFechar', 'fechaCobro', 'terminal', 'promocion']
										    if (attribute(pagoTarjeta, field) is defined) %}
										    {{ form_row(attribute(pagoTarjeta, field)) }}
										{% endfor %}
									</div>
									<div class="col-xs-6">
										{% for field in ['numeroTarjeta', 'vigencia', 'codigoSeguridad', 'tipoTarjeta', 'banco',]
										    if (attribute(pagoTarjeta, field) is defined) %}
										    {{ form_row(attribute(pagoTarjeta, field)) }}
										{% endfor %}
									</div>
								</div>
							{% endfor %}
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="panel panel-default" id="pie_venta">
		<div class="panel-body">
			<button class="btn btn-default" id="btnLimpiar" type="button">Limpiar datos</button>
			<button class="btn btn-default" id="btnLimpiarTodo" type="button">Limpiar Llamada</button>
		</div>
	</div>

	{{ form_rest(form) }}
	{{ form_end(form) }}
</div>

<div class="modal fade modal_base" id="preview" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	<div class="modal-dialog  modal-lg">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Cancelar</span></button>
				<h4 class="modal-title" id="myModalLabel">Resumen de venta</h4>
			</div>
			<div class="modal-body" id="previewBody"></div>
			<div class="modal-footer">
				<button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
				<button type="button" onclick="enviar()" class="btn btn-primary">Terminar Venta</button>
			</div>
		</div>
	</div>
</div>

<!--POPUP VALIDACION SUPERVISOR-->
<div class="modal fade bs-example-modal-sm modal_base" id="pf_supervisor" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-sm">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
        <h4 class="modal-title" id="myModalLabel">Ingrese usuario y contraseña de <b>SUPERVISOR</b></h4>
      </div>
      <div class="modal-body">
      		  <div class="form-group">
			    <div class="input-group">
			      <div class="input-group-addon"><span class="icon-user"></span></div>
			      <input class="form-control" type="password" placeholder="Usuario" id="user_sup">
			    </div>
			  </div>
        	  <div class="form-group">
			    <div class="input-group">
			      <div class="input-group-addon"><span class="icon-key"></span></div>
			      <input class="form-control" type="password" placeholder="Contraseña" id="pass_sup">
			    </div>
			  </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
        <button type="button" class="btn btn-primary" id="btn_validar_supervisor">Aceptar</button>
      </div>
    </div>
  </div>
</div>

<script type="text/template" id='previewBodyTemplate'>
	<div><b>Cliente: </b><span class="cliente"><%= cliente.toString %></span></div>
	<div class="panel panel-default">
  		<div class="panel-body">
			<div><b>Dirección: </b><%= direccion.toString %></div>
			<div><b>Referencia: </b><%= direccion.referencia %></div>
			<div><b>Telefonos Casa: </b><%= direccion.telCasa %>&nbsp;&nbsp;&nbsp;<b>Oficina: </b><%= direccion.telOficina %>&nbsp;&nbsp;&nbsp;<b>Celular: </b><%= direccion.telCel %></div>
  		</div>
	</div>
	<table class="preview">
		<thead>
			<tr>
				<th>Cantidad</th>
				<th>Descripción</th>
				<th>Promocion</th>
				<th>PU</th>
				<th>Total</th>
			</tr>
		</thead>
		<tbody>
			<% _.each(productos.models,function(item, key){ %>
	        	<tr>
	        		<td><%= item.get("cantidad") %></td>
	        		<td><%= item.get("item").producto.descripcion %></td>
	        		<td><%= item.get("item").materialPrecio %></td>
	        		<td><%= accounting.formatMoney(item.get("item").precio) %></td>
	        		<td><%= accounting.formatMoney(item.get("cantidad") * item.get("item").precio) %></td>
	        	</tr>
			<% }); %>
	        <tr>
				<td colspan="3" rowspan="4"></td>
				<td>SubTotal</td>
				<td><b><%= accounting.formatMoney(subTotal) %></b></td>
			</tr>
			<% 
				var totalDescuento = 0;
				_.each(descuentos.models,function(item, key){
					totalDescuento += item.get("importe");
			}); %>
			<tr>
				<td>Descuento</td>
				<td><%= accounting.formatMoney(totalDescuento) %></td>
			</tr>
			<tr>
				<td>Envío</td>
				<td><%= accounting.formatMoney(gastosEnvio) %></td>
			</tr>
			<tr>
				<td>Total</td>
				<td><b><%= accounting.formatMoney(total) %></b></td>
			</tr>
		</tbody>
	</table>
	<div class="row">
		<div class="col-xs-4"><b>Tipo de pago: </b><%= tipoPago.descripcion %></div>
		{#<div class="col-xs-4"><b>RFC: </b><%= requiereRFC == 1 ? rfc : "No" %></div>#}
	</div>
	<% if(tipoPago.value == 1){ %>
	<div class="panel panel-default">
  		<div class="panel-body">
			<div class="row">
				<div class="col-xs-9"><b>Titular: </b><%= pagoTC.titular %></div>
				<div class="col-xs-3"><b>Es Titular: </b><%= pagoTC.esTitular == 1 ? "Sí" : "No" %></div>
			</div>
			<div class="row">
				<div class="col-xs-6"><b>No. Tarjeta: </b><%= pagoTC.numTC %></div>
				<div class="col-xs-3"><b>Vigencia: </b><%= pagoTC.vigencia %></div>
				<div class="col-xs-3"><b>Código: </b><%= pagoTC.codigoVerificacion %></div>
			</div>
			<div class="row">
				<div class="col-xs-4"><b>Tipo: </b><%= pagoTC.tipoTarjeta %></div>
				<div class="col-xs-4"><b>Banco: </b><%= pagoTC.banco %></div>
				<div class="col-xs-4"><b>Promoción: </b><%= pagoTC.promocion %></div>
			</div>
		</div>
	</div>
	<% } %>
</script>
{% include 'MDRPuntoVentaBundle:Pedidos:datosVenta.html.twig' %}
<div class="modal fade modal_base" id="modalClientNew" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
        <h4 class="modal-title" id="myModalLabel">Crear Cliente</h4>
      </div>
      <div class="modal-body">
        {{ form(formClient) }}
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
        <button type="button" class="btn btn-primary" id="saveCliente">Guardar Cliente</button>
      </div>
    </div>
  </div>
</div>

<div class="modal fade modal_base" id="modalDireccionNueva" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-lg">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
        <h4 class="modal-title" id="myModalLabel">Crear Dirección</h4>
      </div>
      <div class="modal-body">
      	<div id="alertSinCobertura" class="alert alert-warning alert-dismissible" style="display:none;">
			{#<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">×</span><span class="sr-only">Close</span></button>#}
			<div><b>Código Postal sin cobertura</b></div>
		</div>
      	{% include 'MDRPuntoVentaBundle:Direcciones:form.html.twig' with {form:formDireccion} only %}
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
        <button type="button" class="btn btn-primary" id="saveDireccion">Guardar Direccion</button>
      </div>
    </div>
  </div>
</div>

{# Edición cliente, direcicón #}

<div class="modal fade modal_base" id="modalClienteEditar" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
        <h4 class="modal-title" id="myModalLabel">Modificar Cliente</h4>
      </div>
      <div class="modal-body" id="bodyClienteEditar">
      	
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
      </div>
    </div>
  </div>
</div>

<div class="modal fade modal_base" id="modalDireccionEditar" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
        <h4 class="modal-title" id="myModalLabel">Modificar Dirección</h4>
      </div>
      <div class="modal-body" id="bodyDireccionEditar">
      	
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
      </div>
    </div>
  </div>
</div>

<style type="text/css">
	
	div.table-container-disponibles
	{
		border: 1px solid #BBB;
		height: 200px;
		max-height: 200px;
		overflow-y: auto;
	}
	div.table-container-seleccionados
	{
		border: 1px solid #BBB;
		height: 150px;
		max-height: 150px;
		overflow-y: auto;
	}
	div.tab-pane
	{
		padding: 4px;
	}
	div.totales
	{
		background-color: #80C040;
		border-radius: 20px;
		color: #fff;
		font-size: 20px;
		font-weight: bold;
		margin-top: -15px;
		padding: 4px 10px;
		text-align: right;
	}
	div.totales span
	{
		font-size: 29px;
	}
	.hide
	{
		display: none;
	}
	#shortInfoCliente
	{
		font-weight: bold;
	}
	#pie_venta
	{
		text-align: right;
	}
</style>
{% endblock %}

{% block javascripts %}
<script type="text/javascript" src="{{ asset('bundles/mdrpuntoventa/js/venta.js') }}"></script>
<script type="text/javascript" src="{{ asset('vendor/datepicker/js/bootstrap-datepicker.js') }}" /></script>
<script type="text/javascript" src="{{ asset('vendor/js/date.js') }}" /></script>

<script type="text/javascript">
	
function makedate(e) {
var keynum = window.event ? window.event.keyCode : e.which;
	if ( keynum == 8 ){ 
		return true;
	}else{
		var fecha = $('#mdr_puntoventabundle_clientes_fechaNacimiento').val();
		if(fecha.length == 2){
			$('#mdr_puntoventabundle_clientes_fechaNacimiento').val(fecha+"/");
		}else if(fecha.length == 5){
			$('#mdr_puntoventabundle_clientes_fechaNacimiento').val(fecha+"/");
		}else if(fecha.length > 10){
			$('#mdr_puntoventabundle_clientes_fechaNacimiento').val(fecha.substr(0, 10));
		}		
	}	
}
	
	urls.cliente = urls.cliente || {};
	urls.cliente.direcciones = "{{ path('clientes_direcciones') }}";
	urls.cliente.clientesByTelefono = "{{ path('clientes_by_telefono', {telefono:'_numero_'}) }}";
	urls.cliente.editAlone = "{{ path('clientes_edit', {id:'_id_'}) }}?tipoRequest=alone";
	urls.cliente.byId = "{{ path('clientes_by_id', {id:'_id_'}) }}";
	urls.direccion = urls.direccion || {};
	urls.direccion.editAlone = "{{ path('direcciones_edit', {id:'_id_', idCliente: '_idCliente_'}) }}?tipoRequest=alone";
	urls.direccion.byId = "{{ path('direcciones_by_id', {idCliente: '_idCliente_', id:'_id_'}) }}";
	urls.tiposPago = urls.tiposPago || {};
	urls.tiposPago.byCP = "{{ path('tipos_pago_by_cp') }}";
	urls.tarjetas = urls.tarjetas || {};
	urls.tarjetas.validar = "{{ path('tarjetas_validar') }}";
	urls.productos = urls.productos || {};
	urls.productos.byDid = "{{ path('productos_by_id', {canal:'_canal_', numero:'_did_'}) }}";
	urls.productos.byCanalOficinaVentas = "{{ path('productos_by_canal_oficinaVentas', {canal:'_canal_', oficinaVentas:'_oficinaVentas_'}) }}";
	urls.validarSupervisor = "{{ path('validar_supervisor') }}";
	urls.pedidos = urls.pedidos || {};
	urls.pedidos.crear = "{{ path('pedidos_create', {canal: canal}) }}";
	
	var inputProductosBase;
	var inputProductosCantidadBase;
	var inputDescuentosBase;
	var myForm = null;
	var cmbTipoPago = null;
	var cmbRFC = null;
	var cmbCliente = null;
	var cmbGastosEnvio = null;
	var cmbDireccionCP = null;
	var cmbDireccionColonia = null;
	var aCambiaGatosenvio = null;
	var aCambiaOficinaVentas = null;


	var tiposPago = new Array();
	var gastosEnvio = {{ gastosEnvio|json_encode()|raw }};
	var gastosEnvioInit = {{ gastosEnvioInit|json_encode()|raw }};
	var origenVentas = {{ origenVentas|json_encode()|raw }};
	var asignaMarcacion = {{ asignaMarcacion|json_encode()|raw }};
	var tipoAccion = {{ title == 'Nueva Venta' ? 'true' : 'false' }};
	var maxDiasPosfecha = {{ maxDiasPosfecha }};

	var mainForm = null;
	var inputProductos = null;
	var inputFechaCobro = null;
	var inputRFC = null;
	var canal = {{ canal }};

	//TDC
	var cmbPosFechar = null;
	var cmbEsTitular = null;
	var inputNumTC = null;
	var inputVigenciaMes = null;
	var inputVigenciaAnio = null;
	var inputTitular = null;
	var inputCodigoVerifacion = null;
	var cmbTipoTajeta = null;
	var cmbTerminal = null;
	var cmbBanco = null;
	var cmbPromocion = null;
	var cmbOficinaVentas = null;

	var botonGuardar = null;
	var botonPreview = null;
	var botonValidarSupervisor = null
	var callData = null;
	var maxTotalCod = {{ maxTotalCod == '' ? 0 : maxTotalCod }};
	var maxTotalTdc = {{ maxTotalTdc == '' ? 0 : maxTotalTdc }};
	var carrito = null;
	var pedido = {{ entity|json_encode()|raw }};
	
	//Edición cliente, direcicón
	var ifrmCliente = null;
	var ifrmDireccion = null;
	var btnEditarCliente = null;
	var btnEditarDireccion = null;

	var btnLimpiar = null;
	var btnLimpiarTodo = null;
	var btnActualizarProductos = null;

	var fechaMin = new Date();
	var fechaMax = new Date();
	var habilitaOficinaSinDNIS = {{ is_granted('ROLE_ATC') ? 'true' : 'false' }};
	var validrLuhn = {{ env == 'Dev' ? 'false' : 'true' }};

	console.debug = console.debug || console.log;

	document.addEventListener("DOMContentLoaded", function(){
		var conexionNuxibaOpen = localStorage.getItem("conexionNuxibaOpen");
        if(conexionNuxibaOpen != 1)
        {
            window.open("{{ path('nuxiba_conexion') }}","conexionNuxiba");
        }
                
		cliente = pedido.cliente;
		idCliente = pedido.cliente == null ? 0 : pedido.cliente.idCliente;
		direccionCliente = pedido.direccion;
		mainForm = document.getElementsByName("mdr_puntoventabundle_pedidos")[0];
		inputProductos = document.getElementById("mdr_puntoventabundle_pedidos_productos");
		inputFechaCobro = document.getElementById("mdr_puntoventabundle_pedidos_productos");
		inputRFC = document.getElementById("mdr_puntoventabundle_pedidos_rfc")
		botonGuardar = document.getElementById("mdr_puntoventabundle_pedidos_submit");
		botonPreview = document.getElementById("botonPreview");
		botonValidarSupervisor = document.getElementById("btn_validar_supervisor");
		cmbTipoPago = document.getElementById("mdr_puntoventabundle_pedidos_pago");
		cmbRFC = document.getElementById("mdr_puntoventabundle_pedidos_factura")
		cmbCliente = document.getElementById("mdr_puntoventabundle_pedidos_cliente");
		cmbGastosEnvio = document.getElementById("mdr_puntoventabundle_pedidos_gastosEnvio");
		cmbDireccionCP = document.getElementById("mdr_puntoventabundle_direcciones_cp");
		cmbDireccionColonia = document.getElementById("mdr_puntoventabundle_direcciones_colonia");

		cmbEsTitular = document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_esTitular");
		inputNumTC = document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_numeroTarjeta");
		inputVigenciaMes = document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_vigencia_month");
		inputVigenciaAnio = document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_vigencia_year");
		inputTitular = document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_titular");
		inputCodigoVerifacion = document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_codigoSeguridad");
		cmbTipoTajeta = document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_tipoTarjeta");
		cmbTerminal = document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_terminal");
		cmbBanco = document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_banco");
		cmbPromocion = document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_promocion");
		cmbOficinaVentas = document.getElementById("form_oficinaVentas");
		cmbPosFechar = document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_posFechar");

		//Edición cliente, direcicón
		btnEditarCliente = document.getElementById("editarCliente");
		btnEditarDireccion = document.getElementById("editarDireccion");

		btnLimpiar = document.getElementById("btnLimpiar");
		btnLimpiarTodo = document.getElementById("btnLimpiarTodo");
		btnActualizarProductos = document.getElementById("actualizarProductos");

		inputProductosBase = document.createElement("input");
		inputProductosBase.type = "hidden";

		inputProductosCantidadBase = inputProductosBase.cloneNode();
		inputDescuentosBase = inputProductosBase.cloneNode();
		inputProductosBase.name = "mdr_puntoventabundle_pedidos[productos][_X_][productoPrecio]";
		inputProductosCantidadBase.name = "mdr_puntoventabundle_pedidos[productos][_X_][cantidad]";
		inputDescuentosBase.name = "mdr_puntoventabundle_pedidos[descuentos][]";

		myForm = document.getElementsByName("mdr_puntoventabundle_pedidos")[0];
		myForm.addEventListener("submit", preEnvio, false);
		botonPreview.addEventListener("click", showPreview);
		//mainForm.addEventListener("submit", submit);
		cmbGastosEnvio.addEventListener("change", calcularTotal);
		cmbGastosEnvio.addEventListener("dblclick", function(){ console.log('gastos envio doble click') });
		cmbDireccionCP.addEventListener("change", changeDireccionCP);
		$(cmbDireccionColonia).on("change", changeDireccionColonia);
		botonValidarSupervisor.addEventListener("click", clickValidaSupervisor);
		cmbOficinaVentas.addEventListener("change", changeOficinaVentas);
		
		//Edición cliente, direcicón
		btnEditarCliente.addEventListener("click", showEditarCliente);
		btnEditarDireccion.addEventListener("click", showEditarDireccion);
		$("#modalClienteEditar").on('hidden.bs.modal', function(e){
			showLoading("Cargando clientes", "#tabCliente");
			$.post(urls.cliente.byId.replace("_id_",cliente.idCliente), {}, function(data, textStatus, xhr) {
				if(data.code == 1)
				{
					cliente = data.entity;
					for (var i = 0; i < clientes.length; i++) {
						if(clientes[i].idCliente == data.entity.idCliente)
						{
							clientes[i] = data.entity;
							carrito.showCliente(clientes[i]);
							try
							{
								$("#mdr_puntoventabundle_pedidos_cliente > [value="+cliente.idCliente+"]").html(cliente.toString);
							}
							catch(err) {
							    console.log(err.message);
							}
						}
					};
				}
				else
				{
					alert(data.messsage);
				}
			}).always(function(){
				hideLoading("#tabCliente");
			});
		});
		$("#modalDireccionEditar").on('hidden.bs.modal', function(e){
			showLoading("Obteniendo direcciones", "#tabDireccion");
			$.post(urls.direccion.byId.replace("_id_", direccionCliente.idDireccion), {}, function(data, textStatus, xhr) {
				if(data.code == 1)
				{
					var cpCambio = false;
					if(direccionCliente.cp != data.entity.cp)
					{
						cpCambio = true;
					}
					direccionCliente = data.entity;
					for (var i = 0; i < direcciones.length; i++)
					{
						if(direcciones[i].idDireccion == data.entity.idDireccion)
						{
							direcciones[i] = data.entity;
							carrito.showDireccion(direcciones[i]);
							try
							{
								$("#mdr_puntoventabundle_pedidos_direccion > [value="+direccionCliente.idDireccion+"]").html(direccionCliente.toString);
							}
							catch(err) {
							    console.log(err.message);
							}
						}
					};
					if(cpCambio)
					{
						fireEvent(nDireccion, "change");
					}
				}
				else
				{
					alert(data.messsage);
				}
			}).always(function(){
		    	hideLoading("#tabDireccion");
		    });
		});

		document.getElementById("nuevoCliente").addEventListener("click", nuevoCliente);
		document.getElementById("nuevaDireccion").addEventListener("click", nuevaDireccion);
		document.getElementById("saveCliente").addEventListener("click", crearCliente);
		document.getElementById("saveDireccion").addEventListener("click", crearDireccion);
		document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_numeroTarjeta").addEventListener("change", validarTarjeta);
		document.getElementById("mdr_puntoventabundle_pedidos_subTotal").addEventListener("change", calcularTotal);
		document.getElementById("mdr_puntoventabundle_pedidos_pago").addEventListener("change", tipoPagoChange);
		cmbPosFechar.addEventListener("change", posFecharChange);

		document.getElementById("mdr_puntoventabundle_direcciones_cliente").parentNode.hidden = true;

		btnLimpiar.addEventListener("click", clickBtnLimpiar);
		btnLimpiarTodo.addEventListener("click", clickBtnLimpiarTodo);
		btnActualizarProductos.addEventListener("click", actualizarProductos);

		addEvent(window, 'storage', storageEvent);
		storageEvents.add('nuxibaRetCall', callReturned);

		//Edición con autorización
		aCambiaGatosenvio = document.createElement("a");
		aCambiaGatosenvio.text = 'Cambiar';
		aCambiaGatosenvio.style.cursor = "pointer";
		aCambiaGatosenvio.addEventListener("click", cambiaGastosEnvio);
		cmbGastosEnvio.parentNode.children[0].appendChild(aCambiaGatosenvio);
		
		aCambiaOficinaVentas = document.createElement("a");
		aCambiaOficinaVentas.text = 'Cambiar';
		aCambiaOficinaVentas.style.cursor = "pointer";
		aCambiaOficinaVentas.addEventListener("click", cambiaOficinaVentas);
		cmbOficinaVentas.parentNode.children[0].appendChild(aCambiaOficinaVentas);

		botonGuardar.style.display = "none";

		inputFechaCobro = document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_fechaCobro");

		//Plugins
		fechaMax.setDate(fechaMin.getDate() + maxDiasPosfecha);
		fechaMin.setHours(0);
		fechaMin.setMinutes(0);
		fechaMin.setSeconds(0);
		fechaMin.setMilliseconds(0);
		fechaMax.setHours(0);
		fechaMax.setMinutes(0);
		fechaMax.setSeconds(0);
		fechaMax.setMilliseconds(0);
		//if(!Modernizr.inputtypes.date)
		if(true)
		{
			$(inputFechaCobro).datepicker({
				format: 		"dd/mm/yyyy",
				orientation: 	"top left",
				onRender: 		function(date){

					return (date.valueOf() >= fechaMin.getTime() && date.valueOf() <= fechaMax.getTime()) ? '' : 'disabled';

				}
			}).on('changeDate', function(ev){
				console.log('date change ext');
				if (ev.date.valueOf() < fechaMin.getTime())
				{
					$(inputFechaCobro).datepicker('setValue', fechaMin);
				}
			});
			/*$("[type=date]").datepicker({
				format: 		"yyyy-mm-dd",
				orientation: 	"top left",
			});*/
		}
		else
		{
			inputFechaCobro.setAttribute("min", formatDate(fechaMin, 'yyyy-MM-dd'));
			inputFechaCobro.setAttribute("max", formatDate(fechaMax, 'yyyy-MM-dd'));
		}

		for(key in gastosEnvio)
		{
			for (var i = 0; i < gastosEnvio[key].length; i++) {
				gastosEnvio[key][i].precio = gastosEnvio[key][i].precio;
				gastosEnvio[key][i].toString = accounting.formatMoney(gastosEnvio[key][i].precio);
			};
		}
		if(origenVentas.oficinaVentas.length)
		{
			cmbOficinaVentas.value = origenVentas.oficinaVentas;
			fireEvent(cmbOficinaVentas, "change");
		}
		if(asignaMarcacion)
		{
			var telefono = asignaMarcacion.telefono;
			var nombreCliente = '';
			if(asignaMarcacion.nombreCliente != null)
			{
				nombreCliente = asignaMarcacion.nombreCliente;
			}
			document.getElementById("callerId").textContent = telefono;
			document.getElementById("mdr_puntoventabundle_clientes_telefono").value = asignaMarcacion.telefono;
			document.getElementById("mdr_puntoventabundle_pedidos_telefono").value = asignaMarcacion.telefono;
			document.getElementById("mdr_puntoventabundle_direcciones_telCasa").value = asignaMarcacion.telefono;
			if(asignaMarcacion.telefono2 != null)
			{
				document.getElementById("mdr_puntoventabundle_direcciones_telOficina").value = asignaMarcacion.telefono2;
			}
			document.getElementById("mdr_puntoventabundle_pedidos_esEntrante").value = 0;
			document.getElementById("shortInfoCliente").textContent = nombreCliente;
		}

		inputFechaCobro.setAttribute('disabled', '');

		carrito = new CarritoView;
		tipoPagoChange();
		{% if title != 'Nueva Venta' %}
			getProductosByDid({{ entity.did.numero }});
		{% endif %}
		$("#mdr_puntoventabundle_pedidos_descuentos").parent().remove();
	})

	var productosDid = null;
	var callbackValidaSupervisor = {};

	//Edición cliente, direcicón
	function showEditarCliente()
	{
		$("#modalClienteEditar").modal("show");
		ifrmCliente = document.createElement("IFRAME"); 
		ifrmCliente.setAttribute("src", urls.cliente.editAlone.replace('_id_', cliente.idCliente));
		ifrmCliente.setAttribute("style", "border: 0;"); 
		ifrmCliente.style.width = 550+"px"; 
		ifrmCliente.style.height = 560+"px";
		$("#bodyClienteEditar").html(ifrmCliente);
	}

	function showEditarDireccion()
	{
		$("#modalDireccionEditar").modal("show");
		ifrmDireccion = document.createElement("IFRAME"); 
		ifrmDireccion.setAttribute("src", urls.direccion.editAlone.replace('_id_', direccionCliente.idDireccion).replace('_idCliente_', cliente.idCliente));
		ifrmDireccion.setAttribute("style", "border: 0;"); 
		ifrmDireccion.style.width = 550+"px"; 
		ifrmDireccion.style.height = 635+"px";
		$("#bodyDireccionEditar").html(ifrmDireccion);
	}

	function posFecharChange()
	{
		if(this.value == '1')
		{
			inputFechaCobro.removeAttribute('disabled');
		}
		else
		{
			inputFechaCobro.setAttribute('disabled', '');
		}
	}

	function clickBtnLimpiar()
	{
		if(confirm("¿Estas seguro de limpiar los datos de la venta?"))
		{
			limpiarDatos();
		}
	}
	function clickBtnLimpiarTodo()
	{
		if(confirm("¿Estas seguro de limpiar los datos de la llamada?"))
		{
			limpiarDatos();
			limpiarDatosLlamada();
		}
	}

	function actualizarProductos()
	{
		var oficinaVentas = cmbOficinaVentas.value;
		if(oficinaVentas.length > 0)
		{
			getProductosByCanalOficinaVentas(canal, oficinaVentas);
		}
		else
		{
			alert("No hay Oficina Ventas seleccionada.");
		}
	}

	function habilitarGatosEnvio(value)
	{
		if(value)
		{
			cmbGastosEnvio.removeAttribute('disabled');
			aCambiaGatosenvio.remove()
		}
		else
		{
			cmbGastosEnvio.removeAttr('disabled');
		}
	}

	function habilitarOficinaVentas(value)
	{
		if(value)
		{
			cmbOficinaVentas.removeAttribute('disabled');
			aCambiaOficinaVentas.remove()
		}
		else
		{
			cmbOficinaVentas.removeAttr('disabled');
		}
	}

	function changeOficinaVentas()
	{
		var oficinaVentas = cmbOficinaVentas.value;
		if(oficinaVentas.length > 0)
		{
			productos.reset();
			carrito.vaciarCarrito();
			getProductosByCanalOficinaVentas(canal, oficinaVentas);
		}
	}

	function cambiaOficinaVentas()
	{
		callbackValidaSupervisor.func = habilitarOficinaVentas;
		callbackValidaSupervisor.args = true;
		showValidaSupervisor();
	}

	function cambiaGastosEnvio()
	{
		callbackValidaSupervisor.func = habilitarGatosEnvio;
		callbackValidaSupervisor.args = true;
		showValidaSupervisor();
	}

	function showValidaSupervisor()
	{
		document.getElementById("user_sup").value = '';
		document.getElementById("pass_sup").value = '';
		$("#pf_supervisor").modal("show");
	}

	function clickValidaSupervisor()
	{
		var user = document.getElementById("user_sup").value;
		var pass = document.getElementById("pass_sup").value;
		validarSupervisor(user, pass, callbackValidaSupervisor.func, callbackValidaSupervisor.args);
	}

	function validarSupervisor(user, pass, callback, args)
	{
		bioSupervisor = new Array();
		bioSupervisor.push({user:user, pass:pass});
		$.post(urls.validarSupervisor, {bioSupervisor: bioSupervisor}, function(data, textStatus, xhr) {
			if(data[0].estatus == 1){
		 		clave = 1;
				$('#user_sup').val("");
				$('#pass_sup').val("");
				alert("Usuario correcto");
				$('#pf_supervisor').modal('hide');
				callback(args);
		 	}else{
		 		$('#user_sup').val("");
				$('#pass_sup').val("");
		 		alert(data[0].mensaje);
		 	}
		});
	}

	function changeDireccionCP()
	{
		validarCoberturaCP(this.value, "alertSinCobertura");
	}
	function changeDireccionColonia()
	{
		validarCoberturaCP(cmbDireccionCP.value, "alertSinCobertura");
	}

	function validarCoberturaCP(cp, elementId)
	{
		showLoading("Validando cobertura de Código Postal");
		getTiposPago(cp, function(entities){
			hideLoading();
			if(entities.length == 0)
			{
				$("#"+ elementId).show();
			}
			else
			{
				$("#" + elementId).hide();
			}
		}, {});
	}


	/*function submit()
	{
		showLoading("Guardando Pedido");
	}*/

	function validarDatosTC()
	{
		var tc = inputNumTC.value.trim();
		if(validrLuhn)
		{
			if(!valid_credit_card(tc))
			{
				alert("Número de tarjeta inválido.");
				return false;
			}
		}
		if(cmbTipoTajeta.value <= 0)
		{
			alert('Indicar tipo de tarjeta');
			return false;
		}
		else
		{
			var tamanoNumeroVerificacion = 3;
			if( cmbTipoTajeta.value == 1 )
			{
				tamanoNumeroVerificacion = 4;
			}

			if(inputCodigoVerifacion.value.length != tamanoNumeroVerificacion )
			{
				alert('El código de verificación debe contener '+tamanoNumeroVerificacion+' dígitos ');
				return false;
			}
		}
		if(cmbBanco.value <= 0)
		{
			alert('Indicar banco');
			return false;
		}
		if(cmbTerminal.value <= 0)
		{
			alert('Indicar terminal');
			return false;
		}
		if(cmbPromocion.value <= 0)
		{
			alert('Indicar promoción');
			return false;
		}
		else
		{
			var montoMinimoPromocion;
			var totalVenta = carrito.getTotal();

			for (var i = 0; i < promociones.length; i++) 
			{
				if( promociones[i].idPromocion == cmbPromocion.value )
				{
					if( promociones[i].montoMinimo > totalVenta  )
					{
						alert('El total es menor al monto mínimo para esta promoción');
						return false;
					}
				}
				
			}

		}
		
		if(!validarVigenciaTDC())
		{
			alert("<b>La vigencia no es valida</b>");
			return false;
		}
		return true;
	}

	function limpiarDatos()
	{
		var form = $("[name=mdr_puntoventabundle_pedidos]")[0];
		form.reset();
		clearSelect(nDireccion);
		direccionCliente = null;
		direcciones = [];
		cliente = null;
		while (productosCompra.length > 0)
		{
			productosCompra.pop();
		}
		carrito.showCliente();
		carrito.showDireccion();
		carrito.render();
	}

	function limpiarDatosLlamada()
	{
		document.getElementById("callerId").textContent = '';
		document.getElementById("mdr_puntoventabundle_clientes_telefono").value = "";
		document.getElementById("mdr_puntoventabundle_pedidos_telefono").value = "";
		document.getElementById("mdr_puntoventabundle_direcciones_telCasa").value = "";
		document.getElementById("mdr_puntoventabundle_pedidos_esEntrante").value  = "";
		document.getElementById("mdr_puntoventabundle_pedidos_did").value = "";
		document.getElementById("shortInfoCliente").textContent = "";
		clientes = [];
		clearSelect(nCliente);
		productosDid = [];
		productos = new ProductosCollection(productosDid);
		carrito.render();
		cmbOficinaVentas.value = '';
	}
	
	function showPreview(evt)
	{
		try {
			var form = $("[name=mdr_puntoventabundle_pedidos]")[0];
			if(!preEnvio(evt))
			{
				return false;
			}
			if(cmbTipoPago.value == 1)
			{
				if(!validarDatosTC())
				{
					return false;
				}
			}
			if(!form.checkValidity())
			{
				alert("Faltan campos por llenar.");
				return false;
			}
			var template = _.template(document.getElementById("previewBodyTemplate").textContent);
			var dataPreview = {
				cliente: cliente,
				direccion: direccionCliente,
				productos: productosCompra,
				descuentos: descuentosCompra,
				subTotal: carrito.subTotal.val(),
				total: carrito.total.val(),
				gastosEnvio: getGastosEnvioSelected(),
				tipoPago: {value: cmbTipoPago.value, descripcion: $(cmbTipoPago).find("option:selected").text()},
				requiereRFC: cmbRFC.value,
				rfc: inputRFC.value,
				pagoTC: {
					esTitular: $(cmbEsTitular).find("option:selected").text(),
					numTC: inputNumTC.value,
					vigencia: $(inputVigenciaAnio).find("option:selected").text() + "/" + $(inputVigenciaMes).find("option:selected").text(),
					titular: inputTitular.value,
					codigoVerificacion: inputCodigoVerifacion.value,
					tipoTarjeta: $(cmbTipoTajeta).find("option:selected").text(),
					banco: $(cmbBanco).find("option:selected").text(),
					promocion: $(cmbPromocion).find("option:selected").text(),
				}
			};
			var html = template(dataPreview);
			$("#previewBody").html(html);
			$("#preview").modal("show");
		}
		catch(err) {
		    alert(err.message);
		}
		
		//evt.preventDefault();
		return false;
	}

	function callReturned(event)
	{
		if(event.newValue.length > 0)
		{
			var data = JSON.parse(event.newValue);
			procesaLlamada(data);
		}
	}

	function procesaLlamada(data)
	{
		var textoTipoLlamada = '';

		data.DNIS = data.DNIS.trim();
		data.phoneNumber = data.phoneNumber.trim();

		try
		{
			var dnis =  data.DNIS.split(" ")[0];
			data.DNIS = dnis;
		}
		catch(err) {
		    console.log(err);
		}
		
		if(data.esEntrante == 1)
		{
			textoTipoLlamada = 'entrante';
		}
		else
		{
			textoTipoLlamada = 'saliente';
		}

		bootbox.dialog({
			message: textoTipoLlamada,
			title: "Llamada activa!!!",
			buttons:
			{
				success:
				{
					label: "Tomar",
					className: "btn-success",
					callback: function()
					{
						tomaLlamada(data);
					}
				},
				main:
				{
					label: "Cancelar",
					className: "btn-primary",
					callback: function()
					{
					}
				}
			}
		});
	}

	function tomaLlamada(data)
	{
		document.getElementById("dnis").textContent = data.DNIS;
		document.getElementById("callerId").textContent = data.phoneNumber;
		document.getElementById("mdr_puntoventabundle_clientes_telefono").value = data.phoneNumber;
		document.getElementById("mdr_puntoventabundle_pedidos_telefono").value = data.phoneNumber;
		console.log("EL NUMERO DE ENTRADA: "+data.phoneNumber);
		var valid = validateNumero(data.phoneNumber);
		if(valid == 1){
			document.getElementById("mdr_puntoventabundle_direcciones_telCasa").value = data.phoneNumber;		
		}else{
			document.getElementById("mdr_puntoventabundle_direcciones_telCasa").value = "";	
		}

		document.getElementById("mdr_puntoventabundle_pedidos_esEntrante").value = data.esEntrante;
		document.getElementById("mdr_puntoventabundle_pedidos_did").value = data.DNIS;

		getClientesByTelefono(data.phoneNumber);
		if(data.DNIS.length > 0)
		{
			getProductosByDid(data.DNIS);
		}
		else if(habilitaOficinaSinDNIS)
		{
			habilitarOficinaVentas(true);
			cmbOficinaVentas.value = '0019';
			changeOficinaVentas();
		}
	}

	function getProductosByDid(did)
	{
		var url = urls.productos.byDid.replace("_canal_", canal).replace("_did_", did);
		showLoading("Cargando productos", "#tabProductos");
		$.get(url, function(data) {
			if(data.code == 1)
			{
				productosDid = data.entities;
				productos = new ProductosCollection(productosDid);
				descuentos = new DescuentosCollection(data.descuentos);
				carrito.render();
				cmbOficinaVentas.value = '';
				message = '';
				if(data.did)
				{
					if(data.did.oficinaVentas)
					{
						if(cmbOficinaVentas.value != data.did.oficinaVentas.claveSAP)
						{
							carrito.vaciarCarrito();
						}
						cmbOficinaVentas.value = data.did.oficinaVentas.claveSAP;
					}
					else
					{
						alert('El Did no está asociado a una Oficina de Ventas.');
					}
				}
				else
				{
					alert('El Did no está asociado a una Oficina de Ventas.');
				}
			}
			else
		    {
		    	alert(data.message);
		    	console.log(data.message);
		    }
		}).always(function(){
			hideLoading("#tabProductos");
		});
	}

	function getProductosByCanalOficinaVentas(canal, oficinaVentas)
	{
		var url = urls.productos.byCanalOficinaVentas.replace("_canal_", canal).replace("_oficinaVentas_", oficinaVentas);
		showLoading("Cargando productos", "#tabProductos");
		$.get(url, function(data) {
			if(data.code == 1)
			{
				productosDid = data.entities;
				productos = new ProductosCollection(productosDid);
				descuentos = new DescuentosCollection(data.descuentos);
				carrito.render();
				if(productosDid.length > 0)
					cmbOficinaVentas.value = productosDid[0].oficinaVenta.claveSAP;
			}
			else
		    {
		    	alert(data.message);
		    	console.log(data.message);
		    }
		}).always(function(){
			hideLoading("#tabProductos");
		});
	}

	function getClientesByTelefono(numero)
	{
		var url = urls.cliente.clientesByTelefono.replace("_numero_", numero);
		showLoading("Cargando clientes", "#tabCliente");
		$.get(url, function(data) {
			console.debug(data);
			if(data.code == 1)
			{
				clearSelect(cmbCliente);
				addOption("----------", 0, cmbCliente);
				clientes = data.entities;
				for (var i = 0; i < clientes.length; i++) {
					var entity = clientes[i];
					addOption(entity.toString, entity.idCliente, cmbCliente);
				};
				if(cliente != null)
				{
					cmbCliente.value = cliente.idCliente;
					fireEvent(cmbCliente, "change");
				}
				if(!(cmbCliente.value > 0) && clientes.length == 1)
				{
					cmbCliente.value = clientes[0].idCliente;
					fireEvent(cmbCliente, "change");
				}
			}
			else
			{
				alert(data.message);
			}
		}).always(function(){
			hideLoading("#tabCliente");
		});
	}

	function tipoPagoChange()
	{
		var panel = document.getElementById("pagoTarjetaPanel");
		var idTipoPago = cmbTipoPago.value;
		
		carrito.vaciarCarrito();
		descuentosCompra.reset();
		carrito.render();
		clearSelect(cmbGastosEnvio);
		if(gastosEnvio[idTipoPago] != undefined)
		{
			for (var i = 0; i < gastosEnvio[idTipoPago].length; i++) {
				gastoEnvio = gastosEnvio[idTipoPago][i];
				addOption(gastoEnvio.toString, gastoEnvio.idGastosEnvio, cmbGastosEnvio);
			};
			cmbGastosEnvio.value = gastosEnvioInit[idTipoPago];
			carrito.totalCompra();
		}
		panel.hidden = !(cmbTipoPago.value == 1);
		if(panel.hidden)
		{
			var items = panel.querySelectorAll("[required]");
			for (var i = 0; i < items.length; i++) {
				items[i].removeAttribute("required");
				items[i].setAttribute("requiredT", "");
			};
		}
		else
		{
			var items = panel.querySelectorAll("[requiredT]");
			for (var i = 0; i < items.length; i++) {
				items[i].removeAttribute("requiredT");
				items[i].setAttribute("required", "");
			};
		}
	}

	function validarMaxTotal()
	{
		if(cmbTipoPago.value == 2)
		{
			var total = accounting.unformat(document.getElementById('mdr_puntoventabundle_pedidos_totalPago').value);
			var res = true;
			if(maxTotalCod != 0 || maxTotalCod != ""){
				res = total <= maxTotalCod;
				if(!res)
				{
					alert("Las ventas COD no pueden superar " + accounting.formatMoney(maxTotalCod) + ".\nEscoga otra opción de pago.");
				}
				return res;
			}else{
				return res;
			}
		}
		else if(cmbTipoPago.value == 1)
		{
			var total = accounting.unformat(document.getElementById('mdr_puntoventabundle_pedidos_totalPago').value);
			var res = true;
			if(maxTotalTdc != 0 || maxTotalTdc != ""){				
				var res = total <= maxTotalTdc;
				if(!res)
				{
					alert("Las ventas TDC no pueden superar " + accounting.formatMoney(maxTotalTdc) + ".");
				}			
				return res;
			}else{
				return res;
			}
		}
	}

	function enviar()
	{
		var inputs = [{item: cmbPosFechar, val: false}, {item: cmbGastosEnvio, val: false}, {item: cmbTipoPago, val: false}, {item: cmbTerminal, val: false},
					{item: inputFechaCobro, val: false}];
		for (var i = 0; i < inputs.length; i++)
		{
			var input = inputs[i];
			input.val = input.item.hasAttribute("disabled");
			if(input.val)
			{
				input.item.removeAttribute("disabled");
			}
		}
		
		var dataForm = $(myForm).serialize();

		for (var i = 0; i < inputs.length; i++)
		{
			var input = inputs[i];
			if(input.val)
			{
				input.item.setAttribute("disabled", "");
			}
		}
		
		showLoading("Guardando Pedido");

		if(preEnvio())
		{
			$.post(urls.pedidos.crear, dataForm, function(data, textStatus, xhr) {
				if(data.code == 1)
				{
					window.onbeforeunload = '';
					window.location = data.url;
				}
				else
				{
					hideLoading();
					alert(data.message);
				}
			});
		}
	}

	function preEnvio(evt)
	{
		if( cmbCliente.value <= 0)
		{
			alert("Falta seleccionar un cliente");
			return;
		}
		if( document.getElementById("mdr_puntoventabundle_pedidos_direccion").value <= 0)
		{
			alert("Falta seleccionar una dirección");
			return;
		}
		var total = accounting.unformat(document.getElementById('mdr_puntoventabundle_pedidos_totalPago').value);
		if(total <= 0)
		{
			alert('El total no puede ser menor o igual a CERO.');
			return false;
		}
		if(!validarMaxTotal())
		{
			return false;
		}
		eliminaProductsInput();
		var cont = 0;
		productosCompra.each(function(item){
			var productoPrecio = item.get("item");
			var inputProducto = inputProductosBase.cloneNode();
			var inputCantidad = inputProductosCantidadBase.cloneNode();

			inputProducto.name = inputProducto.name.replace("_X_", cont);
			inputCantidad.name = inputCantidad.name.replace("_X_", cont);
			
			inputProducto.value = productoPrecio.idProductoPrecio;
			inputCantidad.value = item.get("cantidad");

			myForm.appendChild(inputProducto);
			myForm.appendChild(inputCantidad);
			cont++;
			
		}, this);

		eliminaDescuentosInput();
		descuentosCompra.each(function(item){
			var inputDescuento = inputDescuentosBase.cloneNode();
			
			inputDescuento.value = item.get("idDescuento");

			myForm.appendChild(inputDescuento);
		}, this);
		// if(!validarMaxTotal())
		// {
		// 	//evt.preventDefault();
		// 	return false;
		// }
		if(productosCompra.length == 0)
		{
			alert("Debe seleccionar por lo menos un producto.");
			//evt.preventDefault();
			return false;
		}
		carrito.subTotal.val(accounting.unformat(carrito.subTotal.val()));
		carrito.total.val(accounting.unformat(carrito.total.val()));

		return true;
	}

	function eliminaProductsInput()
	{
		var items = myForm.querySelectorAll("[name*='mdr_puntoventabundle_pedidos[productos]']");
		for (var i = 0; i < items.length; i++) {
			items[i].remove();
		};
	}

	function eliminaDescuentosInput()
	{
		var items = myForm.querySelectorAll("[name*='mdr_puntoventabundle_pedidos[descuentos][]']");
		for (var i = 0; i < items.length; i++) {
			items[i].remove();
		};
	}

	function validarTarjeta()
	{
		var tc = this.value.trim();
		if(validrLuhn)
		{
			if(!valid_credit_card(tc))
			{
				alert("Número de tarjeta inválido.");
				return false;
			}
		}
		$.post(urls.tarjetas.validar, {tc: tc}, function(data, textStatus, xhr) {
			resetDatosTajeta();
			if(data.code == 1)
			{
				if(data.banco != null)
				{
					cmbBanco.value = data.banco.idBanco;
					if(data.banco.idBanco == 56)
					{
						cmbPosFechar.value = 1;
						cmbPosFechar.setAttribute("disabled","");
					}
					else
					{
						cmbPosFechar.removeAttribute("disabled","");
					}
				}
				if(data.terminal != null)
				{
					cmbTerminal.value = data.terminal.idTerminal;
				}
				if(data.tipoTarjeta != null)
				{
					cmbTipoTajeta.value = data.tipoTarjeta.idTipoTarjeta;
				}
				clearSelect(cmbPromocion);
				addOption("", "", cmbPromocion);
				promociones = data.promociones;
				if(!promociones)
					promociones = [];
				for (var i = 0; i < promociones.length; i++) {
					addOption(promociones[i].toString +' - '+ accounting.formatMoney(promociones[i].montoMinimo), promociones[i].idPromocion, cmbPromocion);
				};
				cmbPromocion.value = promociones[0].idPromocion;
			}
			else
			{
				alert(data.message);
			}
		});
	}

	function validarVigenciaTDC()
	{
	  var fechaHoy = new Date();
	  fechaHoy = new Date(fechaHoy.getFullYear(), fechaHoy.getMonth(), 1);
	  return fechaHoy < getVigencia();
	}

	function getVigencia()
	{
	  return new Date(inputVigenciaAnio.value, parseInt(inputVigenciaMes.value) - 1);
	}

	function resetDatosTajeta()
	{
		document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_banco").value = 0;
		document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_terminal").value = 0;
		document.getElementById("mdr_puntoventabundle_pedidos_pagosTarjeta_0_tipoTarjeta").value = 0;
		cmbPosFechar.removeAttribute("disabled","");
	}

	function getGastosEnvioSelected()
	{
		var idTipoPago = cmbTipoPago.value;
		if(idTipoPago > 0)
		{
			for (var i = 0; i < gastosEnvio[idTipoPago].length; i++)
			{
				if(gastosEnvio[idTipoPago][i].idGastosEnvio == cmbGastosEnvio.value)
				{
					return gastosEnvio[idTipoPago][i].precio;
				}
			}
		}
		return 0;
	}

	function calcularTotal()
	{
		var subTotal = parseFloat(accounting.unformat(document.getElementById("mdr_puntoventabundle_pedidos_subTotal").value));
		var gastoEnvio = getGastosEnvioSelected();
		var total =  subTotal + gastoEnvio;
		document.getElementById("mdr_puntoventabundle_pedidos_totalPago").value = accounting.formatMoney(total);
	}

	function nuevoCliente()
	{
		$("#modalClientNew").modal("show");
		return false;
	}
	function nuevaDireccion()
	{
		if(idCliente > 0)
		{
			$("#modalDireccionNueva").modal("show");
			$("#mdr_puntoventabundle_direcciones_cliente").append('<option value="' + idCliente + '">');
			document.getElementById("mdr_puntoventabundle_direcciones_cliente").value = idCliente;
		}
		else
		{
			alert("Primero debe seleccionar un cliente");
		}
		return false;
	}

	function crearCliente()
	{
		var $form = $("#clientes_form");
		showLoading("Guardando cliente");

		$.post($form.attr('action'), $form.serialize(), function(data){
            if(data.code == 1 ){
                $form.each (function(){
                    this.reset();
                });
                cliente = data.cliente;
                clientes.push(cliente);
                idCliente = cliente.idCliente;
                $("#modalClientNew").modal("hide");
                var option = addOption(data.cliente.toString, data.cliente.idCliente, document.getElementById("mdr_puntoventabundle_direcciones_cliente"));
                var option = addOption(data.cliente.toString, data.cliente.idCliente, document.getElementById("mdr_puntoventabundle_pedidos_cliente"));
                option.selected = true;
                fireEvent(cmbCliente, "change");
            }
            else
            {
            	alert(data.message);
            }
        }).always(function(){
        	hideLoading();
        });
        return false;
	}

	function crearDireccion()
	{
		var $form = $("#direcciones_form");

		if(! $form[0].checkValidity() )
		{
			//alert("Faltan datos");
			var mensajeFormularioInvalido = "Faltan los siguientes campos:"; 
			
			for (var cont = 0; cont < $form[0].elements.length; cont++)
			{
				if(! $form[0].elements[cont].validity.valid )
				{
					mensajeFormularioInvalido += "<br/> * "+$('label[for="'+$form[0].elements[cont].id+'"]').text();
				}
			}
			alert(mensajeFormularioInvalido);

			return false;
		}else if($('#mdr_puntoventabundle_direcciones_telCasa').val().length < 10){
			alert('El número telefonico de casa debe ser a 10 digitos incluyendo clave lada.');
			return false;
		}

		showLoading("Guardando cliente");

		$.post($form.attr('action'), $form.serialize(), function(data){
            if(data.code == 1 ){
                $form.each (function(){
                    this.reset();
                });
                clearSelect(cmbColonias);
				clearSelect(cmbDelegacion);
                $("#modalDireccionNueva").modal("hide");
                var option = addOption(data.direccion.toString, data.direccion.idDireccion, document.getElementById("mdr_puntoventabundle_pedidos_direccion"));
                direccionCliente = data.direccion;
                direcciones.push(direccionCliente);
                option.selected = true;
                fireEvent(document.getElementById("mdr_puntoventabundle_pedidos_direccion"), "change");
            }
            else
            {
            	$("#modalDireccionNueva").modal("hide");
            	alert(data.message);
            }
        }).always(function(){
        	hideLoading();
        });
        return false;
	}

	function getFedexByCP(cp, callback, callbackArgs)
	{
		$.post(urls.fedex.byCP, {cp: cp}, function(data, textStatus, xhr) {
			if(data.code == 1)
			{
				fedexEntities = data.entities;
			}
			else
			{
				fedexEntities = new Array();
			}
			callback(fedexEntities, callbackArgs);
		});
	}

	function getTiposPago(cp, callback, callbackArgs)
	{
		showLoading("Cargando Tipos de Pago", "#tabPago");
		$.post(urls.tiposPago.byCP, {cp: cp}, function(data, textStatus, xhr) {
			if(data.code == 1)
			{
				tiposPago = data.entities;
			}
			else
			{
				tiposPago = new Array();
			}
			callback(tiposPago, callbackArgs);
		}).always(function(){
			hideLoading("#tabPago");
		});
	}

	function setTiposPago(direccion)
	{
		getTiposPago(direccion.cp, handleTiposPago, {select: cmbTipoPago});
	}
	function handleTiposPago(entities, args)
	{
		var select = args.select;
		
		clearSelect(select);
		if(entities.length == 0)
		{
			$("#alertSinCoberturaDireccion").show();
		}
		else
		{
			$("#alertSinCoberturaDireccion").hide();
		}
		for (var i = 0; i < entities.length; i++) {
			addOption(entities[i].tipoPago.descripcion, entities[i].tipoPago.idTipoPago, select);
		};
		tipoPagoChange();
	}

	function getTiempoEntrega(){
		var pago = $('#mdr_puntoventabundle_pedidos_pago').val();
		var direccion = $('#mdr_puntoventabundle_pedidos_direccion').val();

		if(pago && direccion){
			var urlConsulta = "{{path('tiempo_entrega')}}"; 
		   	showLoading('Consultando');
		   $.post(urlConsulta, {pago:pago,direccion:direccion}, function(data, textStatus, xhr) {

			  	hideLoading();
			  	alert(data.mensaje);
			   
			});
		}else{
			alert("Debe seleccionar:</br>->Direccion del cliente</br>->Tipo de Pago");
		}
	}
</script>
<script type="text/javascript" src="{{ asset('bundles/mdrpuntoventa/js/filterList.js') }}"></script>

{% endblock %}

{% block stylesheets %}
<link rel="stylesheet" type="text/css" href="{{ asset('vendor/datepicker/css/datepicker.css') }}" rel="stylesheet">

<style type="text/css">
	#preview div {
		margin-top: 4px;
		margin-bottom: 4px;
	}
	table.preview
	{
		width: 100%;
	}
	table.preview tr td, table.preview tr th
	{
		border: 1px solid;
		padding: 2px 12px;
	}
	div.busqueda
	{
		margin-bottom: 10px;
	}
	#container-nuxiba
	{
		position: absolute;
		bottom: 0;
		left: 0;
		opacity: 0.1;
	}
	#mdr_puntoventabundle_pedidos_pago
	{
		display: inline-block;
		width: auto;
	}
	#filtroProductos{
		width: 68%;
		display: inline-block;
	}
</style>
{% endblock stylesheets %}